<template>
    <div class="content-header" v-loading.fullscreen.lock="fullscreenLoading">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0">Ordenes</h1>
                </div><!-- /.col -->
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->

        <div class="card p-1">
            <div class="row">
                <div class="col-4">
                    <label class="mt-2">ID</label>
                    <vs-input v-model="filter_id" />
                </div>
                <div class="col-4">
                    <label class="mt-2">Estado</label>
                    <vs-select v-model="filter_status">
                        <vs-option></vs-option>
                        <vs-option v-for="item in estados" :key="item" :label="item" :value="item">
                            {{ item }}
                        </vs-option>
                    </vs-select>
                </div>
                <div class="col-4">
                    <label class="mt-2">Fecha</label>
                    <vs-input type="date" v-model="filter_date" />
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-2">
                    <button type="button" class="btn btn-info" @click.prevent="getLista()">
                        <i class="fa fa-filter"></i> Filtrar
                    </button>
                </div>
            </div>
        </div>

        <div class="card">
            <template>
                <div class="center">
                    <vs-table>
                        <template #header>
                            <vs-input v-model="search" border placeholder="Buscar" />
                        </template>
                        <template #thead>
                            <vs-tr>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'id')">
                                    ID
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'amount')">
                                    Monto
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'id_seller')">
                                    ID seller
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'status')">
                                    Estado
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'created_at')">
                                    Creado
                                </vs-th>
                                <vs-th>-</vs-th>
                            </vs-tr>
                        </template>
                        <template #tbody>
                            <vs-tr :key="i" v-for="(tr, i) in $vs.getPage($vs.getSearch(listas, search), page, max)"
                                :data="tr">
                                <vs-td>
                                    {{ tr.id }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.amount }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.id_seller }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.status }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.created_at }}
                                </vs-td>
                                <vs-td>
                                    <div class="btn-group">
                                        <button type="button" class="btn btn-info" @click.prevent="showModalView(tr)">
                                            <i class="fa fa-eye"></i>
                                        </button>
                                        <button type="button" class="btn btn-primary" @click.prevent="showModalUpdate(tr)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                        <button type="button" class="btn btn-danger" @click.prevent="eliminarRegistro(tr)">
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </div>
                                </vs-td>
                            </vs-tr>
                        </template>
                        <template #footer>
                            <vs-pagination v-model="page" :length="$vs.getLength($vs.getSearch(listas, search), max)" />
                        </template>
                    </vs-table>
                </div>
            </template>
        </div>

        <vs-dialog overflow-hidden v-model="active_update">
            <template #header>
                <h4 class="not-margin text-primary">
                    Editar Orden
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Monto" v-model="amount" />
                <br />
                <vs-input label-placeholder="Descripción" v-model="description" />
                <br />
                <vs-input label-placeholder="ID Seller" v-model="id_seller" />
                <br />
                <vs-input label-placeholder="Creado" v-model="created_at" disabled />
                <br />
                <label class="mt-2">Estado</label>
                <vs-select v-model="status">
                    <vs-option v-for="item in estados" :key="item" :label="item" :value="item">
                        {{ item }}
                    </vs-option>
                </vs-select>
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitUpdate()">
                        Actualizar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>

        <vs-dialog overflow-hidden v-model="active_view">
            <template #header>
                <h4 class="not-margin text-primary">
                    Orden {{ id }}
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Monto" v-model="amount" disabled />
                <br />
                <vs-input label-placeholder="Descripción" v-model="description" disabled />
                <br />
                <vs-input label-placeholder="ID Seller" v-model="id_seller" disabled />
                <br />
                <vs-input label-placeholder="Creado" v-model="created_at" disabled />
                <br />
                <vs-input label-placeholder="Estado" v-model="status" disabled />
                <br />
            </div>
        </vs-dialog>
    </div>
</template>

<script>
export default {
    data: () => ({
        fullscreenLoading: false,
        page: 1,
        max: 5,
        search: '',
        estados: ['CREATE', 'PENDING', 'SUCCESS', 'EXPIRED', 'REJECTED'],
        active_update: false,
        active_view: false,
        listas: [],

        id: 0,
        amount: 0,
        id_seller: 0,
        description: '',
        status: '',
        created_at: '',

        filter_id: '',
        filter_status: '',
        filter_date: ''
    }),
    mounted() {
        this.getLista();
    },
    methods: {
        getLista() {
            this.fullscreenLoading = true;
            const url = '/ordenes/index' +
                `?id=${this.filter_id}` +
                `&status=${this.filter_status}` +
                `&created_at=${this.filter_date}`;
            axios.get(url)
                .then(response => {
                    this.listas = response.data;
                    this.fullscreenLoading = false;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener las ordenes')
                });
        },
        showModalView(item) {
            this.fullscreenLoading = true;
            this.id = item.id;
            axios.get('/ordenes/' + this.id)
                .then(response => {
                    this.fullscreenLoading = false;
                    const { amount, id_seller, description, status, created_at } = response.data;

                    this.amount = amount;
                    this.id_seller = id_seller;
                    this.description = description;
                    this.status = status;
                    this.created_at = created_at;

                    this.active_view = true;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener las orden')
                });
        },
        showModalUpdate(item) {
            this.fullscreenLoading = true;
            this.id = item.id;
            axios.get('/ordenes/' + this.id)
                .then(response => {
                    this.fullscreenLoading = false;
                    const { amount, id_seller, description, status, created_at } = response.data;

                    this.amount = amount;
                    this.id_seller = id_seller;
                    this.description = description;
                    this.status = status;
                    this.created_at = created_at;

                    this.active_update = true;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener las orden')
                });
        },
        submitUpdate() {
            this.fullscreenLoading = true;

            const updateData = {
                amount: this.amount,
                description: this.description,
                id_seller: this.id_seller,
                status: this.status
            };

            axios.put('/ordenes/update/' + this.id, updateData)
                .then((res) => {
                    this.active_update = false;
                    this.clearFields();
                    this.openNotification('top-left', 'success', 'Petición exitosa', res.data.message);
                    this.getLista();
                }).catch((error) => {
                    this.fullscreenLoading = false;
                    let msg = this.msgErros(error);
                    this.openNotification('top-left', 'danger', 'Error en servidor', msg)
                });
        },
        eliminarRegistro(item) {
            this.$swal.fire({
                title: '¿Estás seguro de eliminar la siguiente orden ' + item.id + '?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Eliminar',
                cancelButtonText: 'Cancelar',
            }).then((result) => {
                if (result.isConfirmed) {
                    this.submitDelete(item);
                }
            });
        },
        submitDelete(item) {
            this.fullscreenLoading = true;
            axios.delete('/ordenes/' + item.id)
                .then((res) => {
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'success', 'Petición exitosa', res.data.message);
                    this.getLista();
                }).catch((error) => {
                    this.fullscreenLoading = false;
                    let msg = this.msgErros(error);
                    this.openNotification('top-left', 'danger', 'Error en servidor', msg)
                });
        },
        openNotification(position = null, color, title, text) {
            this.$vs.notification({
                color,
                position,
                title: title,
                text: text
            });
        },
        clearFields() {
            this.amount = '';
            this.description = '';
            this.id_seller = '';
            this.created_at = '';
            this.status = '';
        },
        msgErros(error) {
            let msg = "";
            if (error.response) {
                console.error(error.response.data);
                const serverErrors = error.response.data.errors;
                for (const field in serverErrors) {
                    msg += `${field}: ${serverErrors[field][0]}<br/>`;
                }
            } else {
                msg = 'No se logro actualizar la orden';
            }
            return msg;
        }
    }
}
</script>